(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ngx-lite/loaders')) :
    typeof define === 'function' && define.amd ? define('@ngx-utilities/ngx-if-else-loading', ['exports', '@angular/core', '@angular/common', '@ngx-lite/loaders'], factory) :
    (global = global || self, factory((global['ngx-utilities'] = global['ngx-utilities'] || {}, global['ngx-utilities']['ngx-if-else-loading'] = {}), global.ng.core, global.ng.common, global.loaders));
}(this, function (exports, core, common, loaders) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxIfElseLoadingDefaultLoadingSpinnerComponent = /** @class */ (function () {
        function NgxIfElseLoadingDefaultLoadingSpinnerComponent() {
        }
        NgxIfElseLoadingDefaultLoadingSpinnerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-if-else-loading-default-loading-spinner',
                        template: "<div class=\"loading\">\r\n  <p *ngIf=\"message\" class=\"message\">\r\n    <strong>{{message}}</strong>\r\n  </p>\r\n  <ngx-loading-spinner></ngx-loading-spinner>\r\n</div>\r\n",
                        styles: [".loading{width:100%;text-align:center}.loading .message{font-size:20px}.loading ngx-loading-spinner{margin:auto}"]
                    }] }
        ];
        NgxIfElseLoadingDefaultLoadingSpinnerComponent.propDecorators = {
            message: [{ type: core.Input }]
        };
        return NgxIfElseLoadingDefaultLoadingSpinnerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT = new core.InjectionToken('NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxIfElseLoadingContext = /** @class */ (function () {
        function NgxIfElseLoadingContext() {
        }
        return NgxIfElseLoadingContext;
    }());
    var NgxIfElseLoadingDirective = /** @class */ (function () {
        function NgxIfElseLoadingDirective(componentFactoryResolver, templateRef, viewContainerRef, ngxIfElseLoadingCustomLoadingComponent) {
            this.componentFactoryResolver = componentFactoryResolver;
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            this.ngxIfElseLoadingCustomLoadingComponent = ngxIfElseLoadingCustomLoadingComponent;
        }
        Object.defineProperty(NgxIfElseLoadingDirective.prototype, "ngxIfElseLoading", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.updateView(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxIfElseLoadingDirective.prototype, "ngxIfElseLoadingWithMessage", {
            set: /**
             * @param {?} message
             * @return {?}
             */
            function (message) {
                this.message = message;
                this.setLoadingComponentMessage();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        NgxIfElseLoadingDirective.prototype.updateView = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value && this.viewRef) {
                this.viewRef.context.$implicit = value;
                this.viewRef.detectChanges();
            }
            else if (value && !this.viewRef) {
                /** @type {?} */
                var context = new NgxIfElseLoadingContext();
                context.$implicit = value;
                this.clear();
                this.viewRef = this.viewContainerRef.createEmbeddedView(this.templateRef, context);
                this.viewRef.detectChanges();
            }
            else if (!value && !this.loadingComponentRef) {
                /** @type {?} */
                var loadingComponent = this.ngxIfElseLoadingCustomLoadingComponent || NgxIfElseLoadingDefaultLoadingSpinnerComponent;
                /** @type {?} */
                var loadingComponentFactory = this.componentFactoryResolver.resolveComponentFactory(loadingComponent);
                this.clear();
                this.loadingComponentRef = this.viewContainerRef.createComponent(loadingComponentFactory);
                this.setLoadingComponentMessage();
            }
        };
        /**
         * @private
         * @return {?}
         */
        NgxIfElseLoadingDirective.prototype.setLoadingComponentMessage = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.loadingComponentRef) {
                this.loadingComponentRef.instance.message = this.message || 'Loading...';
                this.loadingComponentRef.changeDetectorRef.detectChanges();
            }
        };
        /**
         * @private
         * @return {?}
         */
        NgxIfElseLoadingDirective.prototype.clear = /**
         * @private
         * @return {?}
         */
        function () {
            this.viewRef = undefined;
            this.loadingComponentRef = undefined;
            this.viewContainerRef.clear();
        };
        NgxIfElseLoadingDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxIfElseLoading]'
                    },] }
        ];
        /** @nocollapse */
        NgxIfElseLoadingDirective.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.TemplateRef },
            { type: core.ViewContainerRef },
            { type: core.Type, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT,] }] }
        ]; };
        NgxIfElseLoadingDirective.propDecorators = {
            ngxIfElseLoading: [{ type: core.Input }],
            ngxIfElseLoadingWithMessage: [{ type: core.Input }]
        };
        return NgxIfElseLoadingDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxIfElseLoadingModule = /** @class */ (function () {
        function NgxIfElseLoadingModule() {
        }
        /**
         * @param {?} customLoadingComponent
         * @return {?}
         */
        NgxIfElseLoadingModule.withCustomLoadingComponent = /**
         * @param {?} customLoadingComponent
         * @return {?}
         */
        function (customLoadingComponent) {
            return {
                ngModule: NgxIfElseLoadingModule,
                providers: [
                    {
                        provide: NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT,
                        useValue: customLoadingComponent
                    }
                ]
            };
        };
        NgxIfElseLoadingModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, loaders.NgxLoadersModule],
                        declarations: [NgxIfElseLoadingDirective, NgxIfElseLoadingDefaultLoadingSpinnerComponent],
                        exports: [NgxIfElseLoadingDirective, NgxIfElseLoadingDefaultLoadingSpinnerComponent],
                        entryComponents: [NgxIfElseLoadingDefaultLoadingSpinnerComponent]
                    },] }
        ];
        return NgxIfElseLoadingModule;
    }());

    exports.NgxIfElseLoadingDirective = NgxIfElseLoadingDirective;
    exports.NgxIfElseLoadingModule = NgxIfElseLoadingModule;
    exports.ɵa = NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT;
    exports.ɵb = NgxIfElseLoadingDefaultLoadingSpinnerComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-utilities-ngx-if-else-loading.umd.js.map
