import { Component, Input, InjectionToken, Directive, ComponentFactoryResolver, TemplateRef, ViewContainerRef, Type, Optional, Inject, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NgxLoadersModule } from '@ngx-lite/loaders';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxIfElseLoadingDefaultLoadingSpinnerComponent {
}
NgxIfElseLoadingDefaultLoadingSpinnerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-if-else-loading-default-loading-spinner',
                template: "<div class=\"loading\">\r\n  <p *ngIf=\"message\" class=\"message\">\r\n    <strong>{{message}}</strong>\r\n  </p>\r\n  <ngx-loading-spinner></ngx-loading-spinner>\r\n</div>\r\n",
                styles: [".loading{width:100%;text-align:center}.loading .message{font-size:20px}.loading ngx-loading-spinner{margin:auto}"]
            }] }
];
NgxIfElseLoadingDefaultLoadingSpinnerComponent.propDecorators = {
    message: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT = new InjectionToken('NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxIfElseLoadingContext {
}
class NgxIfElseLoadingDirective {
    /**
     * @param {?} componentFactoryResolver
     * @param {?} templateRef
     * @param {?} viewContainerRef
     * @param {?=} ngxIfElseLoadingCustomLoadingComponent
     */
    constructor(componentFactoryResolver, templateRef, viewContainerRef, ngxIfElseLoadingCustomLoadingComponent) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.ngxIfElseLoadingCustomLoadingComponent = ngxIfElseLoadingCustomLoadingComponent;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set ngxIfElseLoading(value) {
        this.updateView(value);
    }
    /**
     * @param {?} message
     * @return {?}
     */
    set ngxIfElseLoadingWithMessage(message) {
        this.message = message;
        this.setLoadingComponentMessage();
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    updateView(value) {
        if (value && this.viewRef) {
            this.viewRef.context.$implicit = value;
            this.viewRef.detectChanges();
        }
        else if (value && !this.viewRef) {
            /** @type {?} */
            const context = new NgxIfElseLoadingContext();
            context.$implicit = value;
            this.clear();
            this.viewRef = this.viewContainerRef.createEmbeddedView(this.templateRef, context);
            this.viewRef.detectChanges();
        }
        else if (!value && !this.loadingComponentRef) {
            /** @type {?} */
            const loadingComponent = this.ngxIfElseLoadingCustomLoadingComponent || NgxIfElseLoadingDefaultLoadingSpinnerComponent;
            /** @type {?} */
            const loadingComponentFactory = this.componentFactoryResolver.resolveComponentFactory(loadingComponent);
            this.clear();
            this.loadingComponentRef = this.viewContainerRef.createComponent(loadingComponentFactory);
            this.setLoadingComponentMessage();
        }
    }
    /**
     * @private
     * @return {?}
     */
    setLoadingComponentMessage() {
        if (this.loadingComponentRef) {
            this.loadingComponentRef.instance.message = this.message || 'Loading...';
            this.loadingComponentRef.changeDetectorRef.detectChanges();
        }
    }
    /**
     * @private
     * @return {?}
     */
    clear() {
        this.viewRef = undefined;
        this.loadingComponentRef = undefined;
        this.viewContainerRef.clear();
    }
}
NgxIfElseLoadingDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngxIfElseLoading]'
            },] }
];
/** @nocollapse */
NgxIfElseLoadingDirective.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: TemplateRef },
    { type: ViewContainerRef },
    { type: Type, decorators: [{ type: Optional }, { type: Inject, args: [NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT,] }] }
];
NgxIfElseLoadingDirective.propDecorators = {
    ngxIfElseLoading: [{ type: Input }],
    ngxIfElseLoadingWithMessage: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxIfElseLoadingModule {
    /**
     * @param {?} customLoadingComponent
     * @return {?}
     */
    static withCustomLoadingComponent(customLoadingComponent) {
        return {
            ngModule: NgxIfElseLoadingModule,
            providers: [
                {
                    provide: NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT,
                    useValue: customLoadingComponent
                }
            ]
        };
    }
}
NgxIfElseLoadingModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, NgxLoadersModule],
                declarations: [NgxIfElseLoadingDirective, NgxIfElseLoadingDefaultLoadingSpinnerComponent],
                exports: [NgxIfElseLoadingDirective, NgxIfElseLoadingDefaultLoadingSpinnerComponent],
                entryComponents: [NgxIfElseLoadingDefaultLoadingSpinnerComponent]
            },] }
];

export { NgxIfElseLoadingDirective, NgxIfElseLoadingModule, NGX_IF_ELSE_LOADING_CUSTOM_LOADING_COMPONENT as ɵa, NgxIfElseLoadingDefaultLoadingSpinnerComponent as ɵb };
//# sourceMappingURL=ngx-utilities-ngx-if-else-loading.js.map
